
#include <SPI.h>
#include <Ethernet.h>


int dataRead(int pin);
const int xpin = A3;                  // x-axis of the accelerometer
const int ypin = A2;                  // y-axis
const int zpin = A1;                  // z-axis (only on 3-axis models)

float zero_G = 512.0;
float scale = 102.3;

bool pocetak = 0;
bool kraj = 0;
int sample = 10;
float prag = 0.5;
unsigned long timestamp_begin;
unsigned long timestamp_end;
unsigned long razlika;
int vrijeme = 1 * 60 * 500;

int rawX;
int rawY;
int rawZ;
float Xacc;
float Yacc;
float Zacc;

// this must be unique
byte mac[] = { 0x90, 0xA2, 0xDA, 0x0D, 0xA8, 0x34 }; 
//brojke na naljepnici od ethernet shielda 
char server[] = " mail.smtp2go.com";
int port = 2525;
EthernetClient client;

void setup() {
  Serial.begin(9600);
  analogReference(EXTERNAL);
  pinMode(xpin,INPUT);
  pinMode(ypin,INPUT);
  pinMode(zpin,INPUT);
  

 
  pinMode(4,OUTPUT);
  digitalWrite(4,HIGH);
  Ethernet.begin(mac);
  delay(2000);
//  Serial.print("IP address: ");
 for (byte thisByte = 0; thisByte < 4; thisByte++) {
// Serial.print(Ethernet.localIP()[thisByte], DEC);
// Serial.print(".");
 }
//  Serial.println(F("Email ready"));
}


void loop() {
  rawX = analogRead(xpin);
  rawY = analogRead(ypin);
  rawZ = analogRead(zpin);
  Xacc = ((float)rawX - zero_G) / scale;
  Yacc = ((float)rawY - zero_G) / scale;
  Zacc = ((float)rawZ - zero_G) / scale;
//  Serial.print(Xacc);
//  Serial.print("\t");
//  Serial.print(Yacc);
//  Serial.print("\t");
//  Serial.print(Zacc);
//  Serial.print("\t");
//  Serial.println();
  delay(100);

  if (pocetak == 0) {
    if (abs(Xacc) > prag || abs(Yacc) > prag) {
      pocetak = 1;
      kraj=0;
      Serial.println("Pocetak");
    }
  }
  else {
    timestamp_begin = millis();
    while (abs(Xacc) < prag && abs(Yacc) < prag) {
      rawX = analogRead(xpin);
      rawY = analogRead(ypin);
      rawZ = analogRead(zpin);
      Xacc = ((float)rawX - zero_G) / scale;
      Yacc = ((float)rawY - zero_G) / scale;
      Zacc = ((float)rawZ - zero_G) / scale;
      timestamp_end = millis();
      razlika = timestamp_end - timestamp_begin;
      delay(10);
//      Serial.println(razlika);
      if (razlika > 10000) {
        kraj = 1;
        Serial.println("Kraj");
        break;
      }
    }
  }
  if (pocetak && kraj) {
    Serial.println("Perilica je gotova");
    if(sendEmail()) Serial.println(F("Email sent"));
      else Serial.println(F("Email failed"));
    pocetak = 0;
    kraj = 0;
  }
}


byte sendEmail()
{
  byte thisByte = 0;
  byte respCode;
 
  if(client.connect(server,port) == 1) {
    Serial.println(F("connected"));
  } else {
    Serial.println(F("connection failed"));
    return 0;
  }
 
  if(!eRcv()) return 0;
 
  Serial.println(F("Sending hello"));
// replace 1.2.3.4 with your Arduino's ip
  client.println("EHLO arduino");
  if(!eRcv()) return 0;
 
  Serial.println(F("Sending auth login"));
  client.println("auth login");
  if(!eRcv()) return 0;
 
  Serial.println(F("Sending User"));
// Change to your base64 encoded user
  client.println("YnVyaXRvMzJAZ21haWwuY29t");
  // idi na https://www.base64encode.org/ i kopiraj enkodirani username
 
  if(!eRcv()) return 0;
 
  Serial.println(F("Sending Password"));
// change to your base64 encoded password
  client.println("bnRwY0g3ZFhvNm9W");
  //isto ko i gore ali samo za password
 
  if(!eRcv()) return 0;
 
// change to your email address (sender)
  Serial.println(F("Sending From"));
  client.println("MAIL From: <burito32@gmail.com>");
  if(!eRcv()) return 0;
 
// change to recipient address
  Serial.println(F("Sending To"));
  client.println("RCPT To: <burito32@gmail.com>");
  if(!eRcv()) return 0;
 
  Serial.println(F("Sending DATA"));
  client.println("DATA");
  if(!eRcv()) return 0;
 
  Serial.println(F("Sending email"));
 
// change to recipient address
  client.println("To: You <burito32@gmail.com>");
 
// change to your address
  client.println("From: Me <burito32@gmail.com>");
 
  client.println("Subject: Perilica\r\n");
 
  client.println("Perilica rublja je gotova");
  //poruka
 
  client.println(".");
 
  if(!eRcv()) return 0;
 
  Serial.println(F("Sending QUIT"));
  client.println("QUIT");
  if(!eRcv()) return 0;
 
  client.stop();
 
  Serial.println(F("disconnected"));
 
  return 1;
}

byte eRcv()
{
  byte respCode;
  byte thisByte;
  int loopCount = 0;
 
  while(!client.available()) {
    delay(1);
    loopCount++;
 
    // if nothing received for 10 seconds, timeout
    if(loopCount > 10000) {
      client.stop();
      Serial.println(F("\r\nTimeout"));
      return 0;
    }
  }
 
  respCode = client.peek();
 
  while(client.available())
  {  
    thisByte = client.read();    
    Serial.write(thisByte);
  }
 
  if(respCode >= '4')
  {
    efail();
    return 0;  
  }
 
  return 1;
}

void efail()
{
  byte thisByte = 0;
  int loopCount = 0;
 
  client.println(F("QUIT"));
 
  while(!client.available()) {
    delay(1);
    loopCount++;
 
    // if nothing received for 10 seconds, timeout
    if(loopCount > 10000) {
      client.stop();
      Serial.println(F("\r\nTimeout"));
      return;
    }
  }
 
  while(client.available())
  {  
    thisByte = client.read();    
    Serial.write(thisByte);
  }
 
  client.stop();
 
  Serial.println(F("disconnected"));
}


